# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

#' Summation of diagonal elements in a matrix
#' @param M A numeric matrix
#' @export
SDM <- function(M) {
    .Call(`_Opt5PL_SDM`, M)
}

#' Transpose of a matrix
#' @param M A numeric matrix
#' @export
Trans <- function(M) {
    .Call(`_Opt5PL_Trans`, M)
}

#' Matrix subtraction
#' @param M1 A numeric matrix
#' @param M2 A numeric matrix
#' @export
Minus <- function(M1, M2) {
    .Call(`_Opt5PL_Minus`, M1, M2)
}

#' Matrix addition
#' @param M1 A numeric matrix
#' @param M2 A numeric matrix
#' @export
Plus <- function(M1, M2) {
    .Call(`_Opt5PL_Plus`, M1, M2)
}

#' Matrix multiplication
#' @param M1 A numeric matrix
#' @param M2 A numeric matrix
#' @export
Multiple <- function(M1, M2) {
    .Call(`_Opt5PL_Multiple`, M1, M2)
}

#' Multiply a constant to a matrix
#' @param s Numeric
#' @param M A numeric matrix
#' @export
sMultiple <- function(s, M) {
    .Call(`_Opt5PL_sMultiple`, s, M)
}

#' Obtain a information matrix at a single design point
#' @param T A numeric vector. Model parameter values
#' @param x numeric. A single design point(dose level)
#' @param order numeric. The number of model paraemters
#' @export
infor <- function(T, x, order) {
    .Call(`_Opt5PL_infor`, T, x, order)
}

#' Obtain normalized Fisher information matrix for the 3,4,5PL models
#' @param W A numeric vector. The first K-1 weights for a given design
#' @param T A numeric vector. Model parameter values
#' @param X A numeric vector. K design points for a given design
#' @param order numeric. The number of model paraemters
#' @export
upinfor <- function(W, T, X, order) {
    .Call(`_Opt5PL_upinfor`, W, T, X, order)
}

#' Matrix calculation
#' @param T A numeric vector. Model parameter values
#' @param x A numeric
#' @param xl A numeric
#' @param inv A numeric matrix.
#' @param order numeric. The number of model paraemters
#' @export
smalld1 <- function(T, x, xl, inv, order) {
    .Call(`_Opt5PL_smalld1`, T, x, xl, inv, order)
}

#' Matrix calculation
#' @param T A numeric vector. Model parameter values
#' @param x1 A numeric
#' @param x2 A numeric
#' @param xl A numeric
#' @param inv A numeric matrix
#' @param order numeric. The number of model paraemters
#' @export
smalldd1 <- function(T, x1, x2, xl, inv, order) {
    .Call(`_Opt5PL_smalldd1`, T, x1, x2, xl, inv, order)
}

#' Matrix calculation
#' @param T A numeric vector. Model parameter values
#' @param x A numeric
#' @param xl A numeric
#' @param inv A numeric matrix
#' @param inv1 A numeric matrix
#' @param order numeric. The number of model paraemters
d11 <- function(T, x, xl, inv, inv1, order) {
    .Call(`_Opt5PL_d11`, T, x, xl, inv, inv1, order)
}

#' Matrix calculation
#' @param T A numeric vector. Model parameter values
#' @param x1 A numeric
#' @param x2 A numeric
#' @param xl A numeric
#' @param inv A numeric matrix
#' @param inv1 A numeric matrix
#' @param order numeric. The number of model paraemters
dd11 <- function(T, x1, x2, xl, inv, inv1, order) {
    .Call(`_Opt5PL_dd11`, T, x1, x2, xl, inv, inv1, order)
}

#' Matrix calculation
#' @param T A numeric vector. Model parameter values
#' @param x A numeric
#' @param order numeric. The number of model paraemters
f <- function(T, x, order) {
    .Call(`_Opt5PL_f`, T, x, order)
}

#' Matrix calculation
#' @param T A numeric vector. Model parameter values
#' @param x A numeric
#' @param inv A numeric matrix
#' @param order numeric. The number of model paraemters
#' @export
smallds1 <- function(T, x, inv, order) {
    .Call(`_Opt5PL_smallds1`, T, x, inv, order)
}

#' Matrix calculation
#' @param T A numeric vector. Model parameter values
#' @param x A numeric
#' @param inv A numeric matrix
#' @param inv1 A numeric matrix
#' @param order numeric. The number of model paraemters
#' @export
ds11 <- function(T, x, inv, inv1, order) {
    .Call(`_Opt5PL_ds11`, T, x, inv, inv1, order)
}

#' EDp
#' @param T A numeric vector. Model parameter values
#' @param p A numeric
#' @export
Dp <- function(T, p) {
    .Call(`_Opt5PL_Dp`, T, p)
}

#' Partial derivative of the EDp w.r.t the model parameters
#' @param T A numeric vector. Model parameter values
#' @param p A numeric
#' @export
g <- function(T, p) {
    .Call(`_Opt5PL_g`, T, p)
}

#' Matrix calculation
#' @param T A numeric vector. Model parameter values
#' @param x A numeric
#' @param xl A numeric
#' @param inv A numeric matrix
#' @param p A numeric
#' @param order numeric. The number of model paraemters
#' @export
D1 <- function(T, x, xl, inv, p, order) {
    .Call(`_Opt5PL_D1`, T, x, xl, inv, p, order)
}

#' Matrix calculation
#' @param T A numeric vector. Model parameter values
#' @param x1 A numeric
#' @param x2 A numeric
#' @param xl A numeric
#' @param inv A numeric matrix
#' @param p A numeric
#' @param order numeric. The number of model paraemters
#' @export
DD1 <- function(T, x1, x2, xl, inv, p, order) {
    .Call(`_Opt5PL_DD1`, T, x1, x2, xl, inv, p, order)
}

#' Matrix calculation
#' @param T A numeric vector. Model parameter values
#' @param x A numeric
#' @param inv A numeric matrix
#' @param p A numeric
#' @param order numeric. The number of model paraemters
#' @export
DS1 <- function(T, x, inv, p, order) {
    .Call(`_Opt5PL_DS1`, T, x, inv, p, order)
}

#' Matrix calculation
#' @param q A numeric vector
#' @param W A numeric vector
#' @param T1 A numeric vector
#' @param T2 A numeric vector
#' @param T3 A numeric vector
#' @param X A numeric vector
#' @param inv1 A numeric matrix
#' @param inv2 A numeric matrix
#' @param inv3 A numeric matrix
#' @export
D_weight_1 <- function(q, W, T1, T2, T3, X, inv1, inv2, inv3) {
    .Call(`_Opt5PL_D_weight_1`, q, W, T1, T2, T3, X, inv1, inv2, inv3)
}

#' Matrix calculation
#' @param q A numeric vector
#' @param W A numeric vector
#' @param T1 A numeric vector
#' @param T2 A numeric vector
#' @param T3 A numeric vector
#' @param X A numeric vector
#' @param inv1 A numeric matrix
#' @param inv2 A numeric matrix
#' @param inv3 A numeric matrix
#' @export
D_weight_2 <- function(q, W, T1, T2, T3, X, inv1, inv2, inv3) {
    .Call(`_Opt5PL_D_weight_2`, q, W, T1, T2, T3, X, inv1, inv2, inv3)
}

#' Matrix calculation
#' @param W A numeric vector
#' @param T A numeric vector
#' @param X A numeric vector
#' @param inv A numeric matrix
#' @param p A numeric
#' @param order numeric. The number of model paraemters
#' @export
c_weight_1 <- function(W, T, X, inv, p, order) {
    .Call(`_Opt5PL_c_weight_1`, W, T, X, inv, p, order)
}

#' Matrix calculation
#' @param W A numeric vector
#' @param T A numeric vector
#' @param X A numeric vector
#' @param inv A numeric matrix
#' @param p A numeric
#' @param order numeric. The number of model paraemters
#' @export
c_weight_2 <- function(W, T, X, inv, p, order) {
    .Call(`_Opt5PL_c_weight_2`, W, T, X, inv, p, order)
}

#' Matrix calculation
#' @param W A numeric vector
#' @param T A numeric vector
#' @param X A numeric vector
#' @param inv A numeric matrix
#' @param inv1 A numeric matrix
#' @param order numeric. The number of model paraemters
#' @export
DD_weight_1 <- function(W, T, X, inv, inv1, order) {
    .Call(`_Opt5PL_DD_weight_1`, W, T, X, inv, inv1, order)
}

#' Matrix calculation
#' @param W A numeric vector
#' @param T A numeric vector
#' @param X A numeric vector
#' @param inv A numeric matrix
#' @param inv1 A numeric matrix
#' @param order numeric. The number of model paraemters
#' @export
DD_weight_2 <- function(W, T, X, inv, inv1, order) {
    .Call(`_Opt5PL_DD_weight_2`, W, T, X, inv, inv1, order)
}

